Summary: interfaces and C++ runtime library for Fresco
Name: Fresco-C++
Version: M1
Release: 1
License: LGPL
Group: Development/Libraries
Source: http://download.fresco.org/releases/%{version}/src/%{name}-%{version}.tar.gz
BuildRoot: /var/tmp/%{name}-buildroot
URL: http://fresco.org/
Prefix: %{_prefix}
Docdir: %{_docdir}
Requires: Prague = %{version}
Requires: Babylon = %{version}

%description
interfaces and C++ runtime library for Fresco

%package devel
Summary: Libraries, includes, etc. to develop applications with Fresco
Group: Development/Libraries
Requires: Fresco-IDL = %{version}
Requires: Prague-devel = %{version}
Requires: Babylon-devel = %{version}

%description devel
all you need to develop applications with the Fresco library

%prep
%setup -q

%build
# Needed for snapshot releases.
if [ ! -f configure ]; then
  CFLAGS="$RPM_OPT_FLAGS" ./autogen.sh --prefix=%prefix --mandir=%{_mandir}
else
  CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%prefix --mandir=%{_mandir}
fi

if [ "$SMP" != "" ]; then
  (make "MAKE=make -k -j $SMP"; exit 0)
  make
else
  make
fi

%install
rm -rf $RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{_mandir}/man1
install -d $RPM_BUILD_ROOT%{_mandir}/man4
make prefix=$RPM_BUILD_ROOT%{prefix} mandir=$RPM_BUILD_ROOT%{_mandir} install

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-, root, root)

%{prefix}/lib/lib*.so
%{prefix}/share/*

%files devel
%defattr(-, root, root)

%{prefix}/include/*
%{prefix}/bin/Fresco-C++-config

%changelog
