/*$Id: SocketAgent.cc,v 1.3 2001/03/27 05:38:42 stefan Exp $
 *
 * This source file is a part of the Berlin Project.
 * Copyright (C) 2000 Stefan Seefeld <stefan@berlin-consortium.org> 
 * http://www.berlin-consortium.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge,
 * MA 02139, USA.
 */
#include "Prague/Sys/Tracer.hh"
#include "Prague/IPC/SocketAgent.hh"
#include <iostream>

using namespace Prague;

SocketAgent::SocketAgent(sockbuf *socket)
  : _socket(socket)
{
  Trace trace("SocketAgent::SocketAgent");
  _socket->async(true);
}

SocketAgent::~SocketAgent()
{
  Trace trace("SocketAgent::~SocketAgent");
  delete _socket;
}

sockbuf *SocketAgent::release_buf()
{
  stop();
  sockbuf *s = _socket;
  _socket = 0;
  return s;
}
